/*@/// Intro */
// Loops

// (c) 2011..2020 Sigrid/Jasper Neumann
// www.sirrida.de / programming.sirrida.de
// E-Mail: info@sirrida.de

// Granted to the public domain
// First version: 2013-02-23
// Last change: 2013-03-04

// Test program
// gcc
/*@\\\+E24C*/

#include "general.c"
#include "modula.h"

/*@/// #define FORx(t,v,s,e,x) */
#define FORx(t,v,s,e,x) \
  { \
    t v,_e_; \
    v=(s); \
    _e_=(e); \
    if (v<=_e_) { \
      while (true) { \
        { x } \
        if (v==_e_) \
          break; \
        ++v; \
        } \
      } \
    }
/*@\\\0000000712+F720*/
/*@/// #define FOR1(t,v,s,e) */
#define FOR1(t,v,s,e) \
  { \
    t v,_e_; \
    v=(s); \
    _e_=(e); \
    if (v<=_e_) { \
      while (true) { \
        {
/*@\\\0000000712+D02D*/
/*@/// #define FOR2(v) */
#define FOR2(v) \
          } \
        if (v==_e_) \
          break; \
        ++v; \
        } \
      } \
    }
/*@\\\+1FE6*/


int main(void) {
  int count;
  t_bool ok;

  if (!init_general()) {
    return 1;
    }

  ok = true;
  printf("Testing loops...\n");

  /*@/// Prototype */
  count = 0;
  {
    t_8u e=255;
    t_8u v=0;
    if (v<=e) {
      while (true) {
        ++count;
        if (v==e)  break;
        ++v;
        }
      }
    }
  IF count != 256 DO
    ok = false;
    printf("Error in prototype loop (0..255): count\n");
    END
  /*@\\\0000000707+7AC6*/
  /*@/// One macro with statement parameter */
  count = 0;
  FORx(t_8u, i, 0, 255,
    IF (int)i != count DO
      ok = false;
      printf("Error in FORx(0..255): value\n");
      END
    ++count;
    )
  IF count != 256 DO
    ok = false;
    printf("Error in FORx(0..255): count\n");
    END
  /*@\\\0000000703+77AE*/
  /*@/// Two macros */
  count = 0;
  FOR1(t_8u, i, 0, 255)
    IF (int)i != count DO
      ok = false;
      printf("Error in FOR1/FOR2(0..255): value\n");
      END
    ++count;
    FOR2(i)
  IF count != 256 DO
    ok = false;
    printf("Error in FOR1/FOR2(0..255): count\n");
    END
  /*@\\\0000000703+8BCF*/
  /*@/// Preferred solution, upward */
  count = 0;
  FOR(t_8u, i, 0, 255)
    IF (int)i != count DO
      ok = false;
      printf("Error in FOR(0..255): value\n");
      END
    ++count;
    END
  IF count != 256 DO
    ok = false;
    printf("Error in FOR(0..255): count\n");
    END
  /*@\\\0000000703+F8CB*/
  /*@/// Preferred solution, downward */
  count = 0;
  FOR_REV(t_8u, i, 255, 0)
    IF (int)i != 255-count DO
      ok = false;
      printf("Error in FOR_REV(255..0): value\n");
      END
    ++count;
    END
  IF count != 256 DO
    ok = false;
    printf("Error in FOR_REV(255..0): count\n");
    END
  /*@\\\0000000703+C71E*/
  /*@/// FOR+break */
  count = 0;
  FOR(t_8u, i, 0, 255)
    if (i==0) {}  // silence compiler
    ++count;
    IF count == 10 DO
      break;
      END
    END
  IF count != 10 DO
    ok = false;
    printf("Error in FOR+break\n");
    END
  /*@\\\0000000401+1A5F*/
  /*@/// FOR+continue */
  count = 0;
  FOR(t_8u, i, 0, 255)
    if (i==0) {}  // silence compiler
    ++count;
    IF count == 10 DO
      continue;
      END
    END
  IF count != 256 DO
    ok = false;
    printf("Error in FOR+continue\n");
    END
  /*@\\\0000000301+B16F*/
  /*@/// LOOP */
  count = 0;
  LOOP(256)
    ++count;
    END
  IF count != 256 DO
    ok = false;
    printf("Error in LOOP: count\n");
    END
  /*@\\\+92A2*/
  /*@/// LOOP+break */
  count = 0;
  LOOP(256)
    ++count;
    IF count == 10 DO
      break;
      END
    END
  IF count != 10 DO
    ok = false;
    printf("Error in LOOP+break\n");
    END
  /*@\\\0000000201+5672*/
  /*@/// LOOP+continue */
  count = 0;
  LOOP(256)
    ++count;
    IF count == 10 DO
      continue;
      END
    END
  IF count != 256 DO
    ok = false;
    printf("Error in LOOP+continue\n");
    END
  /*@\\\0000000810+2AAA*/
  IF ok DO
    printf("OK\n");
    END

  return ok ? 0 : 1;
  }

// eof.
/*@\\\0000002413+138E*/
